commit 193edf237676f4c99bced37f9a976ee52b305e44
Author: freddy77 <freddy77>
Date:   Mon Sep 14 10:02:13 2009 +0000

    limit stack use in dblib tests

diff --git a/ChangeLog b/ChangeLog
index 6090ed0..5207092 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Sep 14 12:02:10 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac src/dblib/unittests/common.c:
+	- limit stack use in dblib tests
+
 Fri Sep  4 09:11:38 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac vms/README.vms: Fix --with-tdsver option
 
@@ -1843,4 +1847,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2870 2009/09/04 07:12:18 freddy77 Exp $
+$Id: ChangeLog,v 1.2871 2009/09/14 10:02:13 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index b65de2f..3653456 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.42 2009/09/04 07:12:18 freddy77 Exp $
+dnl $Id: configure.ac,v 1.43 2009/09/14 10:02:13 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.42 $)
+AC_REVISION($Revision: 1.43 $)
 
 AM_INIT_AUTOMAKE
 AC_CONFIG_HEADERS(include/config.h)
@@ -256,6 +256,7 @@ AC_CHECK_HEADERS([	errno.h \
 			sys/stat.h \
 			sys/time.h \
 			sys/types.h \
+			sys/resource.h \
 			sys/wait.h \
 			unistd.h \
 			wchar.h ])
@@ -438,7 +439,7 @@ AC_CHECK_FUNCS([vsnprintf _vsnprintf gettimeofday \
 nl_langinfo locale_charset setenv putenv \
 getuid getpwuid getpwuid_r fstat alarm fork \
 gethrtime localtime_r setitimer _lseeki64 _telli64 \
-_fseeki64 _ftelli64])
+_fseeki64 _ftelli64 setrlimit])
 OLD_LIBS="$LIBS"
 LIBS="$LIBS $NETWORK_LIBS"
 AC_CHECK_FUNCS([inet_ntoa_r getipnodebyaddr getipnodebyname \
diff --git a/src/dblib/unittests/common.c b/src/dblib/unittests/common.c
index 0eedcab..93ab234 100644
--- a/src/dblib/unittests/common.c
+++ b/src/dblib/unittests/common.c
@@ -12,9 +12,17 @@
 #include <sys/param.h>
 #endif /* HAVE_SYS_PARAM_H */
 
+#if HAVE_SYS_TIME_H
+#include <sys/time.h>
+#endif /* HAVE_SYS_TIME_H */
+
+#if HAVE_SYS_RESOURCE_H
+#include <sys/resource.h>
+#endif /* HAVE_SYS_RESOURCE_H */
+
 #include "replacements.h"
 
-static char software_version[] = "$Id: common.c,v 1.38 2009/09/01 05:47:31 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.39 2009/09/14 10:02:13 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 typedef struct _tag_memcheck_t
@@ -122,6 +130,17 @@ read_login_info(int argc, char **argv)
 	static const char *PWD = "../../../PWD";
 	struct { char *username, *password, *servername, *database; char fverbose; } options;
 
+#if defined(HAVE_SETRLIMIT) && defined(RLIMIT_STACK)
+#define MAX_STACK (8*1024*1024)
+
+	struct rlimit rlim;
+
+	if (!getrlimit(RLIMIT_STACK, &rlim) && (rlim.rlim_cur == RLIM_INFINITY || rlim.rlim_cur > MAX_STACK)) {
+		rlim.rlim_cur = MAX_STACK;
+		setrlimit(RLIMIT_STACK, &rlim);
+	}
+#endif
+
 	setbuf(stdout, NULL);
 	setbuf(stderr, NULL);
 	

